import multiprocessing as mp
import time as tm


def mysum(a, s):
    s.value = sum(range(a[0], a[1]))


if __name__ == '__main__':
    value = [1, 25000000, \
             50000000, 75000000, \
             100000000]
    start = tm.process_time()
    with mp.Manager() as manager:
        data = [manager.list([value[i], value[i + 1]])
                for i in range(0, 4)]
        s = [manager.Value('i', 0) for i in data]
        argzip = zip(data,s)
        p = [mp.Process(target=mysum, args=a)
             for a in argzip]
        ps = [pi.start() for pi in p]
        pj = [pi.join() for pi in p]
        r = sum([si.value for si in s])
        end = tm.process_time()
        print(r, 'time:', end - start)
    start = tm.process_time()
    r = sum(range(1, value[-1]))
    end = tm.process_time()
    print(r, 'serial time:', end - start)
