import multiprocessing as mp
import time as tm

def mysum(a, b, q):
    temp = sum(range(a,b))
    q.put(temp)

if __name__ == '__main__':
    value1 = 25000000
    value2 = 50000000
    value3 = 75000000
    value4 = 100000000
    start = tm.process_time()
    q = mp.Queue()
    p4 = mp.Process(target=mysum, args=(value3, value4, q,))
    p3 = mp.Process(target=mysum, args=(value2, value3, q,))
    p2 = mp.Process(target=mysum, args=(value1, value2, q,))
    p4.start()
    p3.start()
    p2.start()
    mysum(1, value1, q)
    s1 = q.get()
    s2 = q.get()
    s3 = q.get()
    s4 = q.get()
    p4.join()
    p3.join()
    p2.join()
    r = s1 + s2 + s3 + s4
    end = tm.process_time()
    print (r, 'time:', end-start)
    start = tm.process_time()
    r = sum(range(1, value4))
    end = tm.process_time()
    print(r, 'serial time:', end-start)
