import multiprocessing as mp
import time as tm

def mysum(a):
    temp = sum(range(a[0], a[1]))
    return temp

if __name__ == '__main__':
    value1 = 25000000
    value2 = 50000000
    value3 = 75000000
    value4 = 100000000
    start = tm.time()
    with mp.Pool(processes=4) as pool:
        s = pool.map(mysum,[[1, value1],\
                            [value1,value2],\
                            [value2,value3],\
                            [value3,value4]])
    r = sum(s)
    end = tm.time()
    print(r, 'time:', end-start)
    start = tm.time()
    r = sum(range(1, value4))
    end = tm.time()
    print(r, 'serial time:', end-start)
