# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 5
# Ενότητα 5.3

from turtle import *
from random import *

print(random())
print(random())

print(randint(10,100))
print(randint(10,100))


# Κύκλοι

speed("fastest")

for i in range(400):
    up()
    x=randint(-600,600)
    y=randint(-400,400)
    goto(x,y)
    down()
    color(random(),random(),random())
    r=randint(5,50)
    circle(r)


# Τρίγωνα

def triangle(r):
    forward(r)
    left(120)
    forward(r)
    left(120)
    forward(r)
    left(120)

clear()

for i in range(400):
    up()
    x=randint(-600,600)
    y=randint(-400,400)
    goto(x,y)
    down()
    color(random(),random(),random())
    r=randint(5,50)
    triangle(r)


# Κύκλοι και τρίγωνα με πρώτους αριθμούς

def is_prime(n):
    if n<2: return 'no'
    for x in range(2,n-1): 
        if n%x==0: return 'no'
    return 'yes'

clear()
for i in range(400):
    up()
    x=randint(-600,600)
    y=randint(-400,400)
    goto(x,y)
    down()
    color(random(),random(),random())
    r=randint(5,50)
    if is_prime(i)=='yes': circle(r)
    else: triangle(r)
    write(i)


# Τόξα
    
circle(50,360)

circle(50,180)

reset()
speed('fastest')
for i in range(10000):
    circle(randint(-50,50),randint(-45,45))


# Σπείρα

reset()
##speed('fastest')
for i in range(20):
    circle(50+10*i,180)


# Τυχαίες σπείρες

def spiral(x,y,arc,times,inner,increment):
    up()
    goto(x,y)
    down()
    for i in range(times):
        circle(inner+increment*i,arc)

reset()
speed('fastest')
for i in range(50):
    color(random(),random(),random())
    x=randint(-600,600)
    y=randint(-400,400)
    arc=randint(-360,360)
    spiral(x,y,arc,randint(10,100),randint(-30,30), randint(-10,10))


# Εσωτερικοί και εξωτερικοί κύκλοι

reset()
##speed('fastest')
for i in range(8):
    circle(150,22.5)
    circle(20)
    circle(150,22.5)
    circle(-20)


# Εσωτερικοί και εξωτερικοί κύκλοι σε σπείρα

reset()
##speed('fastest')
for i in range(300):
    color("black")
    circle(30+i,15)
    color("blue")
    circle(10)
    color("green")
    circle(30+i,15)
    color("red")
    circle(-5)


# Μαργαρίτα 1

reset()
speed('fastest')
color('red')
for i in range(36):
    circle(75)
    left(10)
color('black')
for i in range(18):
    circle(150)
    left(20)


# Μαργαρίτα 2

def daisy(inner, outer, number, colour):
    angle=360/number
    radius=-(outer-inner)/2
    color(colour)
    up()
    goto(0,0)
    right(90)
    forward(inner)
    left(90)
    for i in range(number):
        down()
        circle(radius)
        up()
        circle(inner,angle)

reset()
speed('fastest')
daisy(60,200,36,'red')
daisy(100,300,20,'blue')
daisy(140,400,50,'green')
