# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 5
# Ενότητα 5.4

from turtle import *
reset()

def koch_curve(distance,degree):
    if degree==0:
        forward(distance)
        return
    dis3=distance/3
    deg1=degree-1
    koch_curve(dis3,deg1)
    left(60)
    koch_curve(dis3,deg1)
    right(120)
    koch_curve(dis3,deg1)
    left(60)
    koch_curve(dis3,deg1)

goto(-300,0)
clear()
koch_curve(600,3)

goto(-300,0)
clear()
koch_curve(600,5)

def dragon_curve(distance, degree, orientation):
    if degree==0:
        forward(distance)
        return
    dis2=distance/(2**0.5)
    deg1=degree-1
    if orientation>0:
        right(45)
        dragon_curve(dis2,deg1,1)
        left(90)
        dragon_curve(dis2,deg1,-1)
        right(45)
    else:
        left(45)
        dragon_curve(dis2,deg1,1)
        right(90)
        dragon_curve(dis2,deg1,-1)
        left(45)

up()
goto(-300,0)
down()
clear()
dragon_curve(600, 5, 1)

up()
goto(-300,0)
down()
clear()
dragon_curve(600, 10, 1)

up()
goto(-300,0)
down()
clear()
speed("fastest")
dragon_curve(600, 15, 1)
