# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 6


# Ενότητα 6.1

a=[14,17,11,22,19,11,33]
print(a)

q=[34, 'hello', -12.17, ['a', 'b']]
print(q)

print(len(a), len(q))

print(a[0], q[1])

print(a[-2], q[-1])

print(a, a[2:5])

a=[1,2]
b=[34,56]
c=a+b
print(c)

d=a*3
print(d)

li = [1, 'Κώστας', 20.5]

x = li[2]

li = 2*li

li = li[0:2]


# Ενότητα 6.2

from winsound import Beep
##def Beep(a,b): pass

Beep(1200,500)

from random import *
for i in range(20):
    freq=randint(1200,20000)
    print(freq,"Hz")
    Beep(freq,200)

List=[220,440,880]
for freq in List:
    print(freq,"Hz")
    Beep(freq,500)

from math import log
print(log(List[2])-log(List[1]))
print(log(List[1])-log(List[0]))

La_List=[]
F=440
while F<=32767:
    La_List=La_List+[F]
    F=F*2

print(La_List)

F=440
while F>=37:
    if not(F in La_List):
        La_List=[F]+La_List
    F=F//2

print(La_List)

def play_list(L,Duration):
    for freq in L:
        print(freq, "Hz")
        Beep(freq,Duration)

play_list(La_List,500)

A=440
d=2**(1/12)
print(d)

L=[A]
for i in range(12):
    A=A*d
    L=L+[A]
print(L)

print(int(2.4), int(2.5), int(2.6))

print(int(0.5+2.4), int(0.5+2.5), int(0.5+2.6))

K=[]
for f in L:
    K=K+[int(0.5+f)]
print(K)

M=[int(0.5+x) for x in L]

print(M)

play_list(M,300)

M2=[int(2*x+0.5) for x in L]
print(M2)
M0=[int(x/2+0.5) for x in L]
print(M0)

Mall=M0+M+M2
print(Mall)

Mall=M0[:12]+M+M2[1:]
print(Mall)

for i in range(20):
    note=randint(0,36)
    freq=Mall[note]
    print("Note=", note, "    Freq=", freq, "Hz")
    Beep(freq,200)

L =[1,2,3,4,5,6,7]

L1 = [x+10 for x in L if x%2]

L1 = []
for x in L:
    if x%2:
        L1.append(x+10)

s1 = "αβγ"
s2 = "χψω"

res = [x+y for x in s1 for y in s2]


# Ενότητα 6.3

a={'La':440, 'La#':466, 'Si':494, 'Do':523}

print(a['La#'])
print(a['Si'], a['Do'])

print(a)

a['Sol']=392
a['Sol#']=415
print(a)

a['Do']=262
print(a)

del a['Do']
print(a)

a={'Do':262, 'Do#':277, 'Re':294, 'Re#':311, 'Mi':330, 'Fa':349, 'Fa#':370, 'Sol':392, 'Sol#':415, 'La':440, 'La#':466, 'Si':494}
print(a)

p=['Do','Mi','Sol','La','La#','La','Sol','Mi']

f=[a[x] for x in p]
print(f)

play_list(f,250)

play_list(f*4,250)

f5=[int(0.5+x*d**5) for x in f]
print(f5)
play_list(f5,250)

f7=[int(0.5+x*d**7) for x in f]
print(f7)
play_list(f7,250)

play_list(f*2+f5+f+f7+f5+f*2,250)

p1=['Do','Re','Mi','Fa','Sol','La','Si']
f1=[a[x] for x in p1]
for i in range(20):
    Beep(f1[randint(0,6)],250)

p2=['Do','Mi','Sol','La','La#']
f2=[a[x] for x in p2]
for i in range(20):
    Beep(f2[randint(0,4)],200)

p3=['Do#','Re#','Fa#','Sol#','La#']
f3=[a[x] for x in p3]
for i in range(20):
    Beep(f3[randint(0,4)],200)

def rand_music(KLIM,OCT,Notes,Speed):
    f=[a[x] for x in KLIM]
    q=[a[x] for x in KLIM]
    while OCT>1:
        OCT=OCT-1
        f=[x*2 for x in f]
        q=q+f
    L=len(q)-1
    for i in range(Notes):
        note=randint(0,L)
        freq=q[note]
        Beep(freq,Speed)

rand_music(['Do#','Re#','Fa#','Sol#','La#'],2,20,250)

a['P']=28000

music=[['La',16],['Sol',16],['La',2],['P',8],['Sol',16], ['Fa',16],['Mi',16],['Re',16],['Do#',4],['Re',2]]

def play_musiclist(L):
    for x in L:
        [note,time]=x
        freq=a[note]
        duration=int(1920/time)
        print("Note=", note, "(", freq, "Hz)", end="")
        print("Dur= 1/",time, "(", duration, "msec)")
        Beep(freq,duration)
        
play_musiclist(music)

epafes = {"Nikos": 6977, "Maria": 6988}

epafes["Nikos"]

for e,t in epafes.items(): print(e, t, sep=": ")

epafes["Nikos"] = 6911

epafes["Κώστας"] = 1234

t = epafes.get("Marina", 0)


# Ενότητα 6.4

weekdays = ("Δε", "Τρ", "Τε", "Πε", "Πα", "Σα", "Κυ")

pi=3,14
print(pi)
type(pi)


# Ενότητα 6.5

print([1,2]+[3,4])

def connect(L1,L2):
    return L1+L2

print(connect([1,2],[3,4]))

L=['a','b','a','c','a','a','d']
print(L.count('a'))

def my_count(A,x):
    return A.count(x)

print(my_count(L,'a'))

v='αβγδε'
print(v.upper())

a={'Do':262, 'Do#':277, 'Re':294, 'Re#':311, 'Mi':330, 'Fa':349, 'Fa#':370, 'Sol':392, 'Sol#':415, 'La':440, 'La#':466, 'Si':494}
print(a.keys())
print(a.values())

print(list(a.keys()))
print(list(a.values()))

L=[1,2,3,4]
L.reverse()
print(L)
L.reverse()
print(L)

L=[1,2,3,4]
M=L
print(L,M)
M.reverse()
print(L,M)

L=[1,2,3,4]
M=[1,2,3,4]

L=[1,2,3,4]
M=L[:]

L=[1,2,3,4]
M=L+[]

print(L,M)
M.reverse()
print(L,M)

L=5
M=L
print(L,M)

M=M+1

print(L,M)

def rev(L):
    M=L+[]
    M.reverse()
    return M

J=[1,2,3,4]
print(J, rev(J), J)

def rev2(L):
    if L==[]: return L
    H=L[0]
    T=L[1:]
    RT=rev2(T)
    return RT+[H]

J=[1,2,3,4]
print(J, rev2(J), J)


# Άσκηση 6.2

mysterysong=[['Do',3,'Σ1'],['Fa',2,'Σ2'],['Fa',1,'Σ3'],['Fa',4,'Σ4'],['Sol',3,'Σ5'],['La',2,'Σ6'],['La',1,'Σ7'],['La',4,'Σ8'],['La',1,'Σ9'],['Sol',1,'Σ10'],['La',1,'Σ11'],['La#',2,'Σ12'],['Mi',2,'Σ13'],['Sol',2,'Σ14'],['Fa',4,'Σ15']]
