# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 10 - Παράδειγμα 6 - toplevel windows

import tkinter as tk
import random
class MyApp():
    def __init__(self, root):
        big_font ='Arial 80'
        screen_x = root.winfo_screenwidth()
        screen_y = root.winfo_screenheight()
        # random colors
        self.r = lambda: random.randint(0, 255) # τυχαίος αριθμός από 0..255
        root.withdraw()
        for i in range(3):
            x= random.randint(0, screen_x - 300)
            y= random.randint(0, screen_y - 300)
            w = tk.Toplevel() # άλλα παράθυρα
            w.geometry('300x300+{}+{}'.format(x,y))
            number = random.randint(100,999)
            l = tk.Label(w, text=str(number), font=big_font, bg = self.random_colour())
            l.pack(expand=True, fill = 'both')
    def random_colour(self):
        return '#{:02X}{:02X}{:02X}'.format(self.r(), self.r(), self.r())
root = tk.Tk() # βασικό παράθυρο
MyApp(root)
root.mainloop()
