# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 10 - Παράδειγμα 6a (Canvas με κόκκινο τεράγωνο)

import tkinter as tk

class MyApp ():
    def __init__(self, root):
        self.root = root
        root.title("Example 6a: red box")
        root.geometry("400x300+300+300") #  παραθύρου 400 x 300 στη θέση (300,300)
        self.create_canvas()

    def create_canvas(self):
        self.canvas = tk.Canvas(self.root)
        self.canvas.pack(fill='both', expand=1)
        size = 200
        top_left_x, top_left_y = 100, 50
        bottom_right_x = top_left_x + size
        bottom_right_y = top_left_y + size
        # δημιουργία τετράγωνου στη θέση top_left_x, top_left_y
        # με πλευρά size
        self.canvas.create_rectangle(top_left_x, top_left_y,
                    bottom_right_x, bottom_right_y, fill='red')

def main():
    root = tk.Tk()
    app = MyApp(root)
    root.mainloop()

if __name__ == '__main__': main()
