# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 14 - Λειτουργικά Συστήματα
# Ενότητα 14.6 Πολυπρογραμματισμός
import threading
from queue import Queue
import time
# κλείδωμα για σειριακή πρόσβαση στην κονσόλα εξόδου
lock = threading.Lock()

def do_work(item):
    for i in range(10000):
        x = (i, i**2, i**i)
    # η εντολή print γίνεται με κλείδωμα για να μην ανακατευτούν οι εκτυπώσεις.
    with lock:
        print(threading.current_thread().name,"εκτελεί την εργασία: ", item)
# η ελαφρά διεργασία worker παίρνει ένα αντικείμενο από την ουρά και το επεξεργάζεται
def worker():
    while True:
        item = q.get()
        do_work(item)
        q.task_done()
# δημιουργία ουράς q.
#main
q = Queue()
for i in range(5):
     t = threading.Thread(target=worker) # h ελαφρά διεργασία δημιουργείται
     t.daemon = True  # .
     t.start()
# stuff work items on the queue (in this case, just a number).
start = time.perf_counter()
for item in range(10):
    q.put(item)
q.join()       # block μέχρι να τελειώσουν όλες οι διεργασίες
print('\nΣυνολικός χρόνος εκτέλεσης των 10 εργασιών: {:.4f}'.format(time.perf_counter() - start))
