import multiprocessing as mp
import time as tm

def mysum(a, b, r):
    temp = sum(range(a,b))
    r.value = temp

if __name__ == '__main__':
    value1 = 25000000
    value2 = 50000000
    value3 = 75000000
    value4 = 100000000
    start = tm.process_time()
    s1 = mp.Value('d', 0.0)
    s2 = mp.Value('d', 0.0)
    s3 = mp.Value('d', 0.0)
    s4 = mp.Value('d', 0.0)
    p4 = mp.Process(target=mysum, args=(value3, value4, s4,))
    p3 = mp.Process(target=mysum, args=(value2, value3, s3,))
    p2 = mp.Process(target=mysum, args=(value1, value2, s2,))
    p4.start()
    p3.start()
    p2.start()
    mysum(1, value1, s1)
    p4.join()
    p3.join()
    p2.join()
    r = s1.value + s2.value + s3.value + s4.value
    end = tm.process_time()
    print (r, 'time:', end-start)
    start = tm.process_time()
    r = sum(range(1,value4))
    end = tm.process_time()
    print(r, 'serial time:', end-start)
