import multiprocessing as mp
import time as tm

def mysum(a,s):
    s.value = sum(range(a[0],a[1]))

if __name__ == '__main__':
    value1 = 25000000
    value2 = 50000000
    value3 = 75000000
    value4 = 100000000
    start = tm.process_time()
    with mp.Manager() as manager:
        data1=manager.list((1, value1))
        data2=manager.list((value1,value2))
        data3=manager.list((value2,value3))
        data4=manager.list((value3,value4))
        s1 = manager.Value('i',0)
        s2 = manager.Value('i',0)
        s3 = manager.Value('i',0)
        s4 = manager.Value('i',0)
        p1 = mp.Process(target=mysum, args=(data1,s1))
        p2 = mp.Process(target=mysum, args=(data2,s2))
        p3 = mp.Process(target=mysum, args=(data3,s3))
        p4 = mp.Process(target=mysum, args=(data4,s4))
        p1.start()
        p2.start()
        p3.start()
        p4.start()
        p1.join()
        p2.join()
        p3.join()
        p4.join()
        r = s1.value + s2.value + s3.value + s4.value
        end = tm.process_time()
        print(r, 'time:', end-start)
    start = tm.process_time()
    r = sum(range(1, value4))
    end = tm.process_time()
    print(r, 'serial time:', end-start)
