import multiprocessing as mp
import time as tm

def mysum(pipe):
    a = pipe.recv()
    b = pipe.recv()
    temp = sum(range(a,b))
    pipe.send(temp)
    pipe.close()

if __name__ == '__main__':
    value1 = 2500000
    value2 = 5000000
    value3 = 7500000
    value4 = 10000000
    start = tm.time()
    pipe1_main, pipe1_child = mp.Pipe()
    pipe2_main, pipe2_child = mp.Pipe()
    pipe3_main, pipe3_child = mp.Pipe()
    pipe4_main, pipe4_child = mp.Pipe()
    p4 = mp.Process(target=mysum, args=(pipe4_child,))
    p3 = mp.Process(target=mysum, args=(pipe3_child,))
    p2 = mp.Process(target=mysum, args=(pipe2_child,))
    p1 = mp.Process(target=mysum, args=(pipe1_child,))
    p4.start()
    p3.start()
    p2.start()
    p1.start()
    pipe2_main.send(value1)
    pipe2_main.send(value2)
    pipe3_main.send(value2)
    pipe3_main.send(value3)
    pipe4_main.send(value3)
    pipe4_main.send(value4)
    pipe1_main.send(1)
    pipe1_main.send(value1)
    s1 = pipe1_main.recv()
    s2 = pipe2_main.recv()
    s3 = pipe3_main.recv()
    s4 = pipe4_main.recv()
    pipe1_main.close()
    pipe2_main.close()
    pipe3_main.close()
    pipe4_main.close()
    p4.join()
    p3.join()
    p2.join()
    p1.join()
    r = s1 + s2 + s3 + s4
    end = tm.time()
    print (r, 'time:', end-start)
    start = tm.time()
    r = sum(range(1, value4))
    end = tm.time()
    print(r, 'serial time:', end-start)
