# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 9
# Ενότητα 9.1

class Card():
    pass

c1=Card()
c2=Card()

c1.value='5'
c1.symbol='d'
c1.color='R'
c1.fig=False

c2.value='K'
c2.symbol='c'
c2.color='B'
c2.fig=True

print(c1.value, c1.symbol, c2.value, c2.symbol)

class Card():
    def __init__(self,val,sym):
        self.value=val
        self.symbol=sym
        if self.symbol in "sc": self.color='B'
        else: self.color='R'
        if self.value in "JQK": self.fig=True
        else: self.fig=False

c1=Card('5','d')
print(c1.value, c1.symbol, c1.color, c1.fig)

print(c1.value, c1.symbol, c1.color, c1.fig)

print(c1)

class Card():
    def __init__(self,val,sym):
        self.value=val
        self.symbol=sym
        if self.symbol in "sc": self.color='B'
        else: self.color='R'
        if self.value in "JQK": self.fig=True
        else: self.fig=False
    def __str__(self):
        return self.value+self.symbol

c1=Card('5', 'd')
print(c1)

class Card():
    def __init__(self,val,sym):
        self.value=val
        self.symbol=sym
        if self.symbol in "sc": self.color='B'
        else: self.color='R'
        if self.value in "JQK": self.fig=True
        else: self.fig=False
    def __str__(self):
        return self.value+self.symbol
    def detailed_info(self):
        print('Αξία=',self.value, '    Σύμβολο=',self.symbol)
        print('Χρώμα=',self.color, '    Φιγούρα=',self.fig)

c1=Card('5', 'd')
c1.detailed_info()

import random

class Deck():
    values="A23456789TJQK"  # Όλες οι αξίες
    symbols="shcd"          # Όλα τα σύμβολα
    def __init__(self):
        self.content=[]    # Χαρτιά που βρίσκονται στην τράπουλα
        self.pile=[]        # Χαρτιά που βγήκαν από την τράπουλα
        for s in Deck.symbols:
            for v in Deck.values:
                c=Card(v,s)
                self.content.append(c)
    def __str__(self):
        s=""
        cntr=0
        for i in self.content:
            s=s+str(i)+" "
            cntr=cntr+1
            if cntr%13==0: s=s+'\n'
        if s[-1]!='\n': s=s+'\n'
        s=s+str(len(self.content))+"-"+str(len(self.pile))
        return s
    def shuffle(self):
        random.shuffle(self.content)
    def draw(self):
        if len(self.content)<1: return "empty"
        c=self.content[0]
        self.content=self.content[1:]
        self.pile.append(c)
        return c
    def collect(self):
        self.content=self.content+self.pile
        self.pile=[]

d=Deck()

print(d)

d.shuffle()

print(d)

h=d.draw()
print(h)
print(d)

for i in range(10): h=d.draw()
print(d)

d.collect()
print(d)
