# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 12
# Ενότητα 12.4.1 Ολοκλήρωση Monte-Carlo

import math, random

def pi():
    count=inside=0
    while True:
        x=random.random()
        y=random.random()
        count+=1
        if x*x+y*y<1: inside+=1
        p=4*inside/count
        if math.isclose(p, math.pi):
            print("Iterations:",count)
            return p

print(pi())
print(pi())
print(pi())
print(pi())

import timeit

print(timeit.timeit(stmt="pi()", number=1, globals=globals()))
print(timeit.timeit(stmt='pi()', number=20, globals=globals()))
