# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 12
# Ενότητα 12.4.2 Αλγόριθμος Gregory-Leibnitz

import math, timeit

def pi():
    count=sum=0
    denom=1
    sign=1
    while True:
        sum+=sign/denom
        count+=1
        p=4*sum
        if math.isclose(p, math.pi):
            print("Iterations:",count)
            return p
        denom+=2
        sign= -sign

print(pi())
print(timeit.timeit(stmt="pi()", number=1, globals=globals()))
print(timeit.timeit(stmt="pi()", number=1, globals=globals()))
