# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 10 - Παράδειγμα 7 - γεγονότα του χρήστη
import tkinter as tk

class MyApp ():
    def __init__(self, root):
        self.root = root
        root.title("Example 7: detecting events")
        root.geometry("400x200+300+300")
        self.create_widgets()

    def create_widgets(self):
        self.root.bind("<Key>", self.handler)
        self.root.bind("<Button-1>", self.focus)
        self.myText = tk.StringVar()
        self.mylabel = tk.Label(self.root, textvariable=self.myText,
                                font="Arial 30",bg="yellow")
        self.mylabel.pack(fill='both', expand=1)

    def handler(self, event):
        print("πατήθηκε: "+repr(event.char))
        self.myText.set( "πατήθηκε: "+str(event.char))
        
    def focus(self, event):
        self.root.focus_set()
        print ("clicked at", event.x, event.y)
        self.myText.set( "κλικ σε: " + str(event.x) + "," + str(event.y))

def main():
    root = tk.Tk()
    app = MyApp(root)
    root.mainloop()

main()
