# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 10 - Παράδειγμα 8 - εφαρμογή mydraw

import tkinter as tk

class MyApp ():
    def __init__(self, root):
        self.root = root
        root.title("Example 8: mydraw")
        root.geometry("800x600+300+300")
        root.resizable(False, False)
        self.create_canvas()

    def create_canvas(self):
        self.canvas = tk.Canvas(self.root, bg='#e0e0ff')
        self.canvas.pack(fill='both', expand=1)
        self.canvas.bind("<Button-1>", self.start_draw)
        self.canvas.bind("<B1-Motion>", self.draw_line)

    def start_draw(self, event):
        self.lastx, self.lasty = event.x, event.y

    def draw_line(self, event):
        self.canvas.create_line((self.lastx, self.lasty,
                                 event.x, event.y), fill='black', width=2)
        self.lastx, self.lasty = event.x, event.y

def main():
    root = tk.Tk()
    app = MyApp(root)
    root.mainloop()

if __name__ == '__main__': main()
