# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 14 - Λειτουργικά Συστήματα
#Ενότητα 14.9 παρουσίαση αρχείων
import os
import os.path

def list_files(start_path):
    max_count = 10
    count = 0
    for root, dirs, files in os.walk(start_path):
        level = root.replace(start_path, '').count(os.sep)
        indent = ' ' * 4 * (level)
        print('{}{}/'.format(indent, os.path.basename(root)))
        sub_indent = ' ' * 4 * (level + 1)
        for f in files:
            print('{}{}'.format(sub_indent, f))
            count +=1
            if count%max_count == 0:
                x = input('..... συνέχεια, [x για έξοδο]:')
                if x == '' or x not in "xXχΧ":
                    continue
                else:
                    return(-1)
    print("Βρέθηκαν {} αρχεία".format(count))
    return(0)

def main():
    while True:
        dir = input('Δώσε αρχικό φάκελο [enter για έξοδο]:')
        if dir == '':
            break
        elif os.path.isdir(dir):
            x = list_files(dir)
            if x == -1 :
                break
        else:
            print('Δεν βρέθηκε ο φάκελος {}'.format(dir))

if __name__ == '__main__':
    main()
