# Ενότητα 14.6 Προγραμματισμός με ελαφρές διεργασίες
import threading
from queue import Queue
import time
import sys

task = sys.argv[1]

def task1():
    time.sleep(.5)

def task2():
    for i in range(10000):
        x = (i, i**2, i**i)
    
def do_work(item):
    if task == "sleep":
        task1()
    elif task == "cpu":
        task2()

# η ελαφρά διεργασία worker παίρνει ένα αντικείμενο από την ουρά και το επεξεργάζεται
def worker():
    while True:
        item = q.get()
        do_work(item)
        q.task_done()
        
# δημιουργία ουράς q.
#main
q = Queue()
for i in range(5):
     t = threading.Thread(target=worker) # δημιουργείται ελαφρά διεργασία
     t.daemon = True  # .
     t.start()
# stuff work items on the queue (in this case, just a number).
start = time.perf_counter()
for item in range(10):
    q.put(item)
q.join()       # block μέχρι να τελειώσουν όλες οι διεργασίες
print('\nΣυνολικός χρόνος εκτέλεσης των 10 εργασιών: {:.4f}'.format(time.perf_counter() - start))
