# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 18 - Διαδικτυακές εφαρμογές
# Ενότητα 18.3 http request to eudoxus
import urllib.request
url =  'https://service.eudoxus.gr/public/departments'
try:
    html_example = urllib.request.urlopen(url)
    encoding_in_header = html_example.headers.get_content_charset()
    charset = encoding_in_header if encoding_in_header else "utf-8"
    for line in html_example:
        line_printable = line.decode(encoding = charset)
        if len(line_printable.strip()) > 0:
            print(line_printable[:-1])
except:
    print('Error in opening', url)
