# Εισαγωγή στους υπολογιστές με τη γλώσσα Python. εκδ.4
# Κεφάλαιο 18 - Διαδικτυακές εφαρμογές
# exchange rates API
import urllib.request
import json

api = "https://exchangeratesapi.io/api/latest?symbols=USD,CNY,RUB,GBP"
currencies = {"USD": 'Δολάριο Αμερικής', "GBP": 'Βρετανική Λίρα',
              "CNY": 'Κινεζικό Γουάν'}
rates = urllib.request.urlopen(api)
therates = rates.read().decode('utf-8')
dict = json.loads(therates)
print(40*'=')
print("Τιμές νομισμάτων - αντιστοιχία σε 1 ευρώ" )
print("Ημερομηνία: {}".format(dict['date']))
print(40*'=')
for currency in currencies:
    print("{:20s}:{:8.4f}".format(currencies[currency], float(dict.get('rates').get(currency))))
print(40*'=')
